## sprng 2.0a

=== Makefile ===
############################################################################
#
# Then typing the command below   => results in the following being created
#      make               => all
#      make src		  => SPRNG library, libsprng, and checksprng, timesprng
#      make examples	  => SPRNG examples
#      make tests	  => Tests of quality of random streams
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#
# Object files, executables, and the libraries can be deleted by typing
#       make realclean
############################################################################

SHELL = /bin/sh

include make.CHOICES

LIBDIR = $(LIB_REL_DIR)
SRCDIR = SRC
DIRS = SRC EXAMPLES TESTS lib

include $(SRCDIR)/make.$(PLAT)

all : src examples tests

src :
	(cd SRC; $(MAKE) ; cd ..)

examples : 
	(cd EXAMPLES; $(MAKE); cd ..) 

tests : 
	(cd TESTS; $(MAKE) ; cd ..)

#---------------------------------------------------------------------------
clean :
	@for l in $(DIRS) ; do \
	  cd $$l ; \
	  $(MAKE) PLAT=$(PLAT) clean ; \
	  cd .. ; \
        done

realclean :
	@for l in $(DIRS) ; do \
	  cd $$l ; \
	  $(MAKE) PLAT=$(PLAT) realclean ; \
	  cd .. ; \
        done
	@rm -f core *~ check* tim* *.data gen*

=== EXAMPLES/Makefile ===
############################################################################
# This is a sample make file to compile some example programs
#
# We have set variables giving information on the archiver, the C compiler 
# and the FORTRAN compiler for certain machines in files make.xxx, where xxx 
# is the machine name, set using the PLAT variable in ../make.CHOICES. 
#
# Then typing the command below    => results in the following being created
#      make                        => Same as: make serial.
#      make serial                 => Single processor examples.
#
#      make mpi                    => Examples using MPI
#
#      make all                    => Single processor and MPI examples.
#
#
# Object files created during the compilation process can be deleted 
# by typing
#       make clean
#
# Set 'LIBDIR' to the directory where the SPRNG libraries are. 
# Set 'INCDIR' to the directory where the SPRNG include files are. 
# We have already set these correctly, unless whoever installed the libraries
# changed the locations.
############################################################################

SHELL = /bin/sh

include ../make.CHOICES

LIBDIR  = ../$(LIB_REL_DIR)
SRCDIR = ../SRC
INCDIR = ../include

# use 'lfg' to get Lagged Fibonacci, 'lcg' to get Linear Congruential, etc. 
SPRNGLIB=sprng
##########################################################################

EX = sprng seed checkpoint invalid_ID sprng-simple simple-simple seed-simple \
     checkpoint-simple spawn sprngf seedf checkpointf invalid_IDf \
     spawnf sprngf-simple simplef-simple seedf-simple checkpointf-simple \
     pi-simple  pif-simple 

MPIEX = sprng_mpi fsprng_mpi 2streams_mpi seed_mpi message_mpi \
        sprng-simple_mpi fsprng-simple_mpi seed-simple_mpi message-simple_mpi \
        sprngf_mpi fsprngf_mpi seedf_mpi messagef_mpi 2streamsf_mpi  \
        sprngf-simple_mpi fsprngf-simple_mpi seedf-simple_mpi \
        messagef-simple_mpi pi-simple_mpi

include $(SRCDIR)/make.$(PLAT)

serial : $(EX)

all: $(EX) $(MPIEX)

mpi : $(MPIEX)

simple-simple : simple-simple.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) -I$(INCDIR) -o simple-simple simple-simple.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprng : sprng.c $(LIBDIR)/libsprng.a
	$(CC) $(CFLAGS) $(CHK) -I$(INCDIR) -o sprng sprng.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprng-simple : sprng-simple.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) -I$(INCDIR) -o sprng-simple sprng-simple.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprng-simple_mpi : sprng-simple_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) -I$(INCDIR) -o sprng-simple_mpi sprng-simple_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

sprng_mpi : sprng_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) $(CHK) -I$(INCDIR) -o sprng_mpi sprng_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

fsprng_mpi : fsprng_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) $(CHK) -I$(INCDIR) -o fsprng_mpi fsprng_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

fsprng-simple_mpi : fsprng-simple_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) -I$(INCDIR) -o fsprng-simple_mpi fsprng-simple_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

2streams_mpi : 2streams_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) $(CHK) -I$(INCDIR) -o 2streams_mpi 2streams_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

seed : seed.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) $(CHK) -I$(INCDIR) -o seed seed.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

seed-simple : seed-simple.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) -I$(INCDIR) -o seed-simple seed-simple.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

seed_mpi : seed_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) $(CHK) -I$(INCDIR) -o seed_mpi seed_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

seed-simple_mpi : seed-simple_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) -I$(INCDIR) -o seed-simple_mpi seed-simple_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

checkpoint : checkpoint.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) $(CHK) -I$(INCDIR) -o checkpoint checkpoint.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

checkpoint-simple : checkpoint-simple.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) -I$(INCDIR) -o checkpoint-simple checkpoint-simple.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

message_mpi : message_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) $(CHK) -I$(INCDIR) -o message_mpi message_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

message-simple_mpi : message-simple_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) -I$(INCDIR) -o message-simple_mpi message-simple_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

pi-simple : pi-simple.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) $(CHK) -I$(INCDIR) -o pi-simple pi-simple.c -L$(LIBDIR) -l$(SPRNGLIB) -lm $(GMPLIB)

pi-simple_mpi : pi-simple_mpi.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPICC) $(CFLAGS) -I$(INCDIR) -o pi-simple_mpi pi-simple_mpi.c -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) -lm $(GMPLIB)

spawn : spawn.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) -DCHECK_POINTERS -I$(INCDIR) -o spawn spawn.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

invalid_ID : invalid_ID.c $(LIBDIR)/lib$(SPRNGLIB).a
	$(CC) $(CFLAGS) -DCHECK_POINTERS -I$(INCDIR) -o invalid_ID invalid_ID.c -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprngf : sprngf.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o sprngf  sprngf.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprngf_mpi : sprngf_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o sprngf_mpi  sprngf_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

fsprngf_mpi : fsprngf_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o fsprngf_mpi  fsprngf_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

seedf : seedf.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o seedf  seedf.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

seedf_mpi : seedf_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o seedf_mpi  seedf_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

checkpointf : checkpointf.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o checkpointf  checkpointf.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(CMDDIR) $(CMDLIB) $(GMPLIB)

messagef_mpi : messagef_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o messagef_mpi  messagef_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)


2streamsf_mpi : 2streamsf_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o 2streamsf_mpi  2streamsf_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

invalid_IDf : invalid_IDf.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o invalid_IDf  invalid_IDf.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

spawnf : spawnf.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o spawnf  spawnf.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)


simplef-simple : simplef-simple.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o simplef-simple  simplef-simple.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprngf-simple : sprngf-simple.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o sprngf-simple  sprngf-simple.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

sprngf-simple_mpi : sprngf-simple_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o sprngf-simple_mpi  sprngf-simple_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

fsprngf-simple_mpi : fsprngf-simple_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o fsprngf-simple_mpi  fsprngf-simple_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

seedf-simple : seedf-simple.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o seedf-simple  seedf-simple.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(GMPLIB)

seedf-simple_mpi : seedf-simple_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o seedf-simple_mpi  seedf-simple_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

checkpointf-simple : checkpointf-simple.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o checkpointf-simple  checkpointf-simple.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(CMDDIR) $(CMDLIB) $(GMPLIB)

messagef-simple_mpi : messagef-simple_mpi.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(MPIF77) $(FFLAGS)  -I$(INCDIR) -o messagef-simple_mpi  messagef-simple_mpi.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) $(MPIDIR) $(MPILIB) $(GMPLIB)

pif-simple : pif-simple.$(FSUFFIX) $(LIBDIR)/lib$(SPRNGLIB).a
	$(F77) $(FFLAGS)  -I$(INCDIR) -o pif-simple  pif-simple.$(FSUFFIX) -L$(LIBDIR) -l$(SPRNGLIB) -lm $(GMPLIB)


.SUFFIXES : 

.SUFFIXES : .f .F

.F.f : 
	@if [ -f $*.i ] ; then \
	rm $*.i ;\
	fi 
	$(CPP) -I$(INCDIR) $*.F
	@if [ -f $*.i ] ; then \
	mv $*.i  $*.f ;\
	fi 

clean :
	rm -f *.o

realclean :
	rm -f *.o $(EX) $(MPIEX) *~ *.i core a.out

=== SRC/Makefile ===
############################################################################
#
# Then typing the command below   => results in the following being created
#      make               => libsprng.a
#                            Timing and checking executibles.
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
############################################################################

SHELL = /bin/sh
include ../make.CHOICES
LIBDIR = ../$(LIB_REL_DIR)
CHKDIR = ..

##############################################################################
####### The following is the only line in this file that you may modify ######
# The default generator
#RNGDEFAULT = lfg 
LIBLIST = lfg lcg lcg64 cmrg mlfg pmlcg 
##############################################################################


include make.$(PLAT)


#---------------------------------------------------------------------------
# Jump point to sprng
#---------------------------------------------------------------------------
all : 
	(cd sprng; $(MAKE) )
	(p=0 ; \
	for l in $(LIBLIST) ; do \
	./insertmenu "printf(\042" $$l $$p "\134\156\042);" ../EXAMPLES/gen_types_header ../EXAMPLES/gen_types_menu.h ; \
	./insertmenu "print *, \047" $$l $$p "\047" ../EXAMPLES/genf_types_header ../EXAMPLES/genf_types_menu.h ; \
	p=$$(($$p+1)) ; \
	done )

#---------------------------------------------------------------------------
# Create files that all generators need
#---------------------------------------------------------------------------
SPRNG_COMMON_DEPEND = primes_32.o primes_64.o \
			fwrap_mpi.o  cputime.o makeseed.o  store.o\
                    simple_mpi.o memory.o  communicate.o  checkid.o

sprng_common : $(SPRNG_COMMON_DEPEND)

primes_32.o : primes_32.h primes_32.c
	$(CC) -c $(CFLAGS) primes_32.c 

primes_64.o : primes_64.h primes_64.c
	$(CC) -c $(CFLAGS) primes_64.c 

fwrap_mpi.o : fwrap.h fwrap_mpi.c
	$(CC) -c $(CFLAGS) $(FFXN) fwrap_mpi.c

cputime.o : cputime.c fwrap.h
	$(CC) -c $(CFLAGS) $(FFXN) cputime.c

makeseed.o : makeseed.c
	$(CC) -c $(CFLAGS) makeseed.c

simple_mpi.o : simple_mpi.c memory.h interface.h
	$(CC) -c $(CFLAGS) simple_mpi.c

memory.o : memory.c
	$(CC) -c $(CFLAGS) memory.c

communicate.o : communicate.c memory.h
	$(CC) -c $(CFLAGS) communicate.c

checkid.o : checkid.c memory.h
	$(CC) -c $(CFLAGS) checkid.c

store.o : store.c store.h
	$(CC) -c $(CFLAGS) store.c


#---------------------------------------------------------------------------
# Create executables to time the generator
#---------------------------------------------------------------------------
timesprng_exec : timesprng_c_exec timesprng_f_exec
	@chmod u+x $(CHKDIR)/timesprng


timesprng_c_exec : $(CHKDIR)/timingc$(TIMESPRNG_LIB)
	(p=0 ; \
	for l in $(LIBLIST) ; do \
	./inserttimecheck $$l $(CHKDIR)/timesprng "Timing C interface:" timingc$(TIMESPRNG_LIB) $(CHKDIR)/timingc$(TIMESPRNG_LIB) $$p ; \
	p=$$(($$p+1)) ; \
	done; )

timesprng_f_exec : $(CHKDIR)/timingf$(TIMESPRNG_LIB)
	(p=0 ; \
	for l in $(LIBLIST) ; do \
	./inserttimecheck $$l $(CHKDIR)/timesprng "Timing FORTRAN interface:" timingf$(TIMESPRNG_LIB) $(CHKDIR)/timingf$(TIMESPRNG_LIB) $$p ; \
	p=$$(($$p+1)) ; \
	done; )

$(CHKDIR)/timingc$(TIMESPRNG_LIB) : timing.o $(LIBDIR)/lib$(TIMESPRNG_LIB).a
	$(CLD) $(CLDFLAGS) -o $(CHKDIR)/timingc$(TIMESPRNG_LIB) timing.o -L$(LIBDIR) -l$(TIMESPRNG_LIB) $(GMPLIB)


$(CHKDIR)/timingf$(TIMESPRNG_LIB) : timingf.o  $(LIBDIR)/lib$(TIMESPRNG_LIB).a
	$(F77LD) $(F77LDFLAGS) -o $(CHKDIR)/timingf$(TIMESPRNG_LIB) timingf.o -L$(LIBDIR) -l$(TIMESPRNG_LIB) $(GMPLIB)


timing.o : timing.c cputime.o
	$(CC) -c $(CFLAGS) timing.c

drand : drand.c cputime.h cputime.o
	$(CC) $(CFLAGS) -o drand drand.c cputime.o

timingf.o : timingf.$(FSUFFIX)
	$(F77) -c $(FFLAGS) timingf.$(FSUFFIX)

#$(LIBDIR)/lib$(TIMESPRNG_LIB).a : $(TIMESPRNG_LIB)/$(TIMESPRNG_LIB).c
#		(cd $(TIMESPRNG_LIB); $(MAKE) $(TIMESPRNG_LIB))


#---------------------------------------------------------------------------
# Create executables to check whether the generator is ported correctly
#---------------------------------------------------------------------------
checksprng_exec : checksprng_c_exec checksprng_f_exec
	@chmod u+x $(CHKDIR)/checksprng


checksprng_c_exec : $(CHKDIR)/check.c$(CHECKSPRNG_LIB) \
		    $(CHKDIR)/check_sim.c$(CHECKSPRNG_LIB) \
		    $(CHKDIR)/check_ptr.c$(CHECKSPRNG_LIB)
	(p=0 ; \
	for l in $(LIBLIST) ; do \
	./insertcheck  $$l $(CHKDIR)/checksprng "Checking Default C interface:" check.c$(CHECKSPRNG_LIB) $(CHKDIR)/check.c$(CHECKSPRNG_LIB) $$p ; \
	./insertcheck  $$l $(CHKDIR)/checksprng "Checking Simple C interface:" check_sim.c$(CHECKSPRNG_LIB) $(CHKDIR)/check_sim.c$(CHECKSPRNG_LIB) $$p ; \
	./insertcheck  $$l $(CHKDIR)/checksprng "Checking C interface with pointer checking:" check_ptr.c$(CHECKSPRNG_LIB) $(CHKDIR)/check_ptr.c$(CHECKSPRNG_LIB) $$p ; \
	p=$$(($$p+1)) ; \
	done; )

checksprng_f_exec : $(CHKDIR)/check.f$(CHECKSPRNG_LIB) \
		    $(CHKDIR)/check_sim.f$(CHECKSPRNG_LIB) \
		    $(CHKDIR)/check_ptr.f$(CHECKSPRNG_LIB)
	(p=0 ; \
	for l in $(LIBLIST) ; do \
	./insertcheck  $$l $(CHKDIR)/checksprng "Checking Default FORTRAN interface:" check.f$(CHECKSPRNG_LIB) $(CHKDIR)/check.f$(CHECKSPRNG_LIB) $$p ; \
	./insertcheck  $$l $(CHKDIR)/checksprng "Checking Simple FORTRAN interface:" check_sim.f$(CHECKSPRNG_LIB) $(CHKDIR)/check_sim.f$(CHECKSPRNG_LIB) $$p ; \
	./insertcheck  $$l $(CHKDIR)/checksprng "Checking FORTRAN interface with pointer checking:" check_ptr.f$(CHECKSPRNG_LIB) $(CHKDIR)/check_ptr.f$(CHECKSPRNG_LIB) $$p ; \
	p=$$(($$p+1)) ; \
	done; )

$(CHKDIR)/check.c$(CHECKSPRNG_LIB) : check_gen.o $(LIBDIR)/lib$(CHECKSPRNG_LIB).a
	$(CLD) $(CLDFLAGS) -o $(CHKDIR)/check.c$(CHECKSPRNG_LIB) check_gen.o \
		-L$(LIBDIR) -l$(CHECKSPRNG_LIB) $(GMPLIB)

$(CHKDIR)/check_sim.c$(CHECKSPRNG_LIB) : check_gen_simple.o $(LIBDIR)/lib$(CHECKSPRNG_LIB).a
	$(CLD) $(CLDFLAGS) -o $(CHKDIR)/check_sim.c$(CHECKSPRNG_LIB) check_gen_simple.o \
		-L$(LIBDIR) -l$(CHECKSPRNG_LIB) $(GMPLIB)

$(CHKDIR)/check_ptr.c$(CHECKSPRNG_LIB) : check_gen_ptr.o $(LIBDIR)/lib$(CHECKSPRNG_LIB).a
	$(CLD) $(CLDFLAGS) -o $(CHKDIR)/check_ptr.c$(CHECKSPRNG_LIB) check_gen_ptr.o \
		-L$(LIBDIR) -l$(CHECKSPRNG_LIB) $(GMPLIB)

$(CHKDIR)/check.f$(CHECKSPRNG_LIB) : check_genf.o $(LIBDIR)/lib$(CHECKSPRNG_LIB).a
	$(F77LD) $(F77LDFLAGS) -o $(CHKDIR)/check.f$(CHECKSPRNG_LIB) check_genf.o \
		-L$(LIBDIR) -l$(CHECKSPRNG_LIB) $(GMPLIB)

$(CHKDIR)/check_sim.f$(CHECKSPRNG_LIB) : check_genf_simple.o $(LIBDIR)/lib$(CHECKSPRNG_LIB).a
	$(F77LD) $(F77LDFLAGS) -o $(CHKDIR)/check_sim.f$(CHECKSPRNG_LIB) check_genf_simple.o \
		-L$(LIBDIR) -l$(CHECKSPRNG_LIB) $(GMPLIB)

$(CHKDIR)/check_ptr.f$(CHECKSPRNG_LIB) : check_genf_ptr.o $(LIBDIR)/lib$(CHECKSPRNG_LIB).a
	$(F77LD) $(F77LDFLAGS) -o $(CHKDIR)/check_ptr.f$(CHECKSPRNG_LIB) check_genf_ptr.o \
		-L$(LIBDIR) -l$(CHECKSPRNG_LIB) $(GMPLIB)

#$(LIBDIR)/lib$(CHECKSPRNG_LIB).a : $(CHECKSPRNG_LIB)/$(CHECKSPRNG_LIB).c
		(cd $(CHECKSPRNG_LIB); $(MAKE) $(CHECKSPRNG_LIB))

check_gen.o : check_gen.c sprng.h
	$(CC) -c $(CFLAGS) check_gen.c

check_gen_simple.o : check_gen_simple.c sprng.h
	$(CC) -c $(CFLAGS) check_gen_simple.c

check_gen_ptr.o : check_gen_ptr.c sprng.h
	$(CC) -c $(CFLAGS) check_gen_ptr.c

check_genf.o : check_genf.$(FSUFFIX) sprng_f.h
	$(F77) -c $(FFLAGS) check_genf.$(FSUFFIX)

check_genf_simple.o : check_genf_simple.$(FSUFFIX) sprng_f.h
	$(F77) -c $(FFLAGS) check_genf_simple.$(FSUFFIX)

check_genf_ptr.o : check_genf_ptr.$(FSUFFIX) sprng_f.h
	$(F77) -c $(FFLAGS) check_genf_ptr.$(FSUFFIX)



.SUFFIXES : 

.SUFFIXES : .f .F

#---------------------------------------------------------------------------
.F.f : 
	@if [ -f $*.i ] ; then \
	rm $*.i ;\
	fi
	$(CPP) $(SRCDIR) $*.F
	@if [ -f $*.i ] ; then \
	mv $*.i  $*.f ;\
	fi

#---------------------------------------------------------------------------
clean :
	rm -f *.o *.i
	@for l in $(LIBLIST) sprng;  do \
	  cd $$l ; \
	  $(MAKE) PLAT=$(PLAT) clean ; \
	  cd .. ; \
        done

realclean :
	rm -f *.o *.f *~ *.i core a.out
	rm -f ../EXAMPLES/gen_types_menu.h ../EXAMPLES/genf_types_menu.h
	@for l in $(LIBLIST) sprng; do \
	  cd $$l ; \
	  $(MAKE) PLAT=$(PLAT) realclean ; \
	  cd .. ; \
	  rm -f $(CHKDIR)/$$l.data; \
        done

=== TESTS/Makefile ===
############################################################################
# This is a make file compiles the test executables
#
# We have set variables giving information on the archiver, the C compiler 
# and the FORTRAN compiler for certain machines in files make.xxx, where xxx 
# is the machine name, set in ../make.CHOICES. 
#
# Typing the command below    => results in the following being created
#      make                        => All the sequential and parallel tests.
#      make xxx                    => Test 'xxx.rng' for each generator 'rng'.
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#
# Object files and the test executables created can be deleted finally
# by typing
#       make realclean
#
# Set 'LIBDIR' to the directory where the SPRNG libraries are. 
# Set 'INCDIR' to the directory where the SPRNG include files are. 
# We have already set them to the correct locations, unless whoever installed
# the libraries changed them.
############################################################################
SHELL = /bin/sh
include ../make.CHOICES
LIBDIR = ../$(LIB_REL_DIR)
INCDIR = ../include
SRCDIR = ../SRC
include $(SRCDIR)/make.$(PLAT)
TESTLIB = sprngtest
#GMPLIB = -lgmp #uncomment for pmlcg

#############################################################################
# Random number libraries

# lcg, lfg, or lcg64 for 48 bit, Fibonacci, and 64 bit LCG cmrg for
# the combined multiple recursive genrator, pmlcg for the prime
# modulus LCG, and mlfg for the multiplicative lagged Fibonacci
# generator respectively.

LIBLIST = sprng

# To create a new test 'xxx', place the source code in file 'xxx.c`
# Then append 'xxx' to TESTLIST below. This assumes that 'xxx.c'
# depends on 'tests.h' and 'util.h' alone. If there are more dependencies,
# then explicitly write the commands for that. 'xxx.yyy' files are created
# for each random number library 'libyyy.a' in LIBLIST.

TESTLIST = maxt collisions equidist serial gap perm runs coupon poker  sum random_walk wolff metropolis
#
# ____________________________________________________________________
# The user should normally not need to change anything below this line
# _____________________________________________________________________
##############################################################################

INCLUDEDIR = -I$(INCDIR)

all : $(LIBDIR)/lib$(TESTLIB).a $(TESTLIST) 

$(LIBDIR)/lib$(TESTLIB).a: init_tests.o util.o \
                           chisquare.o stirling.o communicate.o 
	$(AR) $(ARFLAGS) $(LIBDIR)/lib$(TESTLIB).a  \
                init_tests.o util.o chisquare.o stirling.o communicate.o 
	$(RANLIB) $(LIBDIR)/lib$(TESTLIB).a

init_tests.o : init_tests.c
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $(DEF) init_tests.c

util.o : util.c
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $(DEF) util.c

stirling.o : stirling.c util.h
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $(DEF) stirling.c

chisquare.o : chisquare.c util.h
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $(DEF) chisquare.c

communicate.o : communicate.c
	$(CC) -c  $(CFLAGS)  $(INCLUDEDIR) $(DEF) communicate.c

$(BASE).o : $(BASE).c tests.h util.h
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $(DEF) $(BASE).c

$(TESTLIST) : 
	@for l in $(LIBLIST) ; do \
	  $(MAKE) LIB=$$l BASE=$@ DEF=$(DEF) PLAT=$(PLAT) \
                  $@.$$l ; \
        done

$(BASE).$(LIB) : $(BASE).o $(LIBDIR)/lib$(TESTLIB).a $(LIBDIR)/lib$(LIB).a
	$(CLD) $(CLDFLAGS) -o $@ $(BASE).o -L$(LIBDIR) -l$(TESTLIB) -l$(LIB) $(GMPLIB) -lm $(MPIDIR) $(MPILIB)

#######################################################################
#  FFT test for parallel RNGs
#

fft : 
	@for l in $(LIBLIST) ; do \
	  $(MAKE) LIB=$$l DEF=$(DEF) PLAT=$(PLAT) \
                  $@.$$l ; \
        done

fft.o : fft.c $(INCDIR)/sprng.h
	$(CC) -c $(CFLAGS) $(INCLUDEDIR) $(DEF) $(CHK) -I$(INCDIR) fft.c 

fft.$(LIB) : fft.o $(LIBDIR)/lib$(TESTLIB).a $(LIBDIR)/lib$(LIB).a
	$(CLD) $(CLDFLAGS) $(INCLUDEDIR) $(DEF) $(CHK) -I$(INCDIR) -o $@ fft.o -L$(LIBDIR) -l$(LIB) -lcomplib.sgimath -lftn $(GMPLIB)


#########################################################################

clean :
	@rm -f *.o

realclean :
	@rm -f *.o $(LIBDIR)/lib$(TESTLIB).a
	@for l in $(LIBLIST) ; do \
	  rm -f *.$$l ; \
        done
	rm -f *~ core a.out
.SUFFIXES :

=== lib/Makefile ===
SHELL = /bin/sh

clean :
	@rm -f *.o

realclean :
	rm -f lib*

.SUFFIXES :

=== SRC/cmrg/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make              => cmrg.o object
#      make cmrg.o	 => cmrg.o object
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#       make realclean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..

include $(SRCDIR)/make.$(PLAT)

all : cmrg.o


cmrg.o : $(SRCDIR)/interface.h cmrg.c  cmrg.h $(SRCDIR)/memory.h  \
		$(SRCDIR)/primes_64.h  $(SRCDIR)/multiply.h \
		$(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS) $(FFXN) $(INLINEOPT)  cmrg.c -I$(SRCDIR)

clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

=== SRC/lcg/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make              => lcg.o object
#      make lcg.o	 => lcg.o object
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#       make realclean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..

include $(SRCDIR)/make.$(PLAT)

all : lcg.o 


lcg.o : $(SRCDIR)/interface.h lcg.c  lcg.h $(SRCDIR)/memory.h  \
		$(SRCDIR)/primes_32.h  $(SRCDIR)/multiply.h \
		$(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS)  $(FFXN) $(INLINEOPT) lcg.c -I$(SRCDIR)
clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

=== SRC/lcg64/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make              => lcg64.o object
#      make lcg64.o	 => lcg64.o object
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#       make realclean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..

include $(SRCDIR)/make.$(PLAT)

all : lcg64.o


lcg64.o : $(SRCDIR)/interface.h lcg64.c  lcg64.h $(SRCDIR)/memory.h  \
		$(SRCDIR)/primes_64.h  $(SRCDIR)/multiply.h \
		$(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS) $(FFXN) $(INLINEOPT) -I$(SRCDIR) lcg64.c 

clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

=== SRC/lfg/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make              => lfg.o object
#      make lfg.o	 => lfg.o object
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#       make realclean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..

include $(SRCDIR)/make.$(PLAT)

all : lfg.o 

lfg.o : $(SRCDIR)/interface.h lfg.c  lfg.h $(SRCDIR)/multiply.h  $(SRCDIR)/memory.h $(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS)  $(FFXN) $(INLINEOPT) lfg.c -I$(SRCDIR)

clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

=== SRC/mlfg/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make               => Fortran and C libraries for the generator,
#                            Timing executibles.
#      make mlfg	  => Library for the Multiplicative LFG
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..

include $(SRCDIR)/make.$(PLAT)

all : mlfg.o 

mlfg.o : $(SRCDIR)/interface.h mlfg.c mlfg.h int64.h  $(SRCDIR)/memory.h $(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS)  $(FFXN) $(INLINEOPT) mlfg.c -I$(SRCDIR)
#---------------------------------------------------------------------------
.F.f : 
	@if [ -f $*.i ] ; then \
	rm $*.i ;\
	fi
	$(CPP) $*.F
	@if [ -f $*.i ] ; then \
	mv $*.i  $*.f ;\
	fi


#---------------------------------------------------------------------------
#---------------------------------------------------------------------------
clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

.SUFFIXES : 

.SUFFIXES : .f .F

=== SRC/pmlcg/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make              => pmlcg.o object
#      make pmlcg.o	 => pmlcg.o object
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
#       make realclean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..

include $(SRCDIR)/make.$(PLAT)

all : pmlcg.o


pmlcg.o : $(SRCDIR)/interface.h pmlcg.c  pmlcg.h $(SRCDIR)/memory.h  basic.h info.h gmp.h longlong.h $(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS)  $(FFXN) $(INLINEOPT) pmlcg.c -I$(SRCDIR)

clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

=== SRC/sprng/Makefile ===
############################################################################
#
# Typing the command below   => results in the following being created
#      make               => Fortran and C libraries for the generator,
#                            Timing executibles.
#      make sprng		  => Library for the Linear Congruential Generator
#
# Object files created during the compilation process can be deleted finally
# by typing
#       make clean
############################################################################

SHELL = /bin/sh

include ../../make.CHOICES

LIBDIR = ../../$(LIB_REL_DIR)
SRCDIR = ..
CHKDIR = ../..
GENLIST = lfg lcg lcg64 cmrg mlfg pmlcg

include $(SRCDIR)/make.$(PLAT)

all : sprng timesprng checksprng


#---------------------------------------------------------------------------
# Construct Library
#---------------------------------------------------------------------------
SPRNG_COMMON_DEPEND = $(SRCDIR)/primes_32.o $(SRCDIR)/primes_64.o \
			  $(SRCDIR)/fwrap_mpi.o  $(SRCDIR)/cputime.o \
		      $(SRCDIR)/makeseed.o  $(SRCDIR)/simple_mpi.o \
		      $(SRCDIR)/memory.o  $(SRCDIR)/communicate.o  \
			  $(SRCDIR)/checkid.o $(SRCDIR)/store.o

sprng :
	(cd ..; $(MAKE) sprng_common)
	@for g in $(GENLIST) ; do \
		(cd ../$$g; $(MAKE) ) ; \
	done
	rm -f $(LIBDIR)/libsprng.a
	$(MAKE) $(LIBDIR)/libsprng.a

$(LIBDIR)/libsprng.a : sprng.o   \
		$(SRCDIR)/lcg/lcg.o $(SRCDIR)/lfg/lfg.o \
		$(SRCDIR)/lcg64/lcg64.o \
		$(SRCDIR)/mlfg/mlfg.o $(SRCDIR)/cmrg/cmrg.o \
		$(SRCDIR)/pmlcg/pmlcg.o \
		$(SPRNG_COMMON_DEPEND)
	$(AR) $(ARFLAGS) $(LIBDIR)/libsprng.a sprng.o \
		$(SRCDIR)/lcg/lcg.o $(SRCDIR)/lfg/lfg.o \
		$(SRCDIR)/lcg64/lcg64.o \
		$(SRCDIR)/mlfg/mlfg.o $(SRCDIR)/cmrg/cmrg.o \
		$(SRCDIR)/pmlcg/pmlcg.o \
		$(SPRNG_COMMON_DEPEND)
	$(RANLIB) $(LIBDIR)/libsprng.a

sprng.o : $(SRCDIR)/interface.h sprng.c   $(SRCDIR)/memory.h  \
	$(SRCDIR)/multiply.h $(SRCDIR)/store.h $(SRCDIR)/fwrap_.h
	$(CC) -c $(CFLAGS)  $(FFXN) $(INLINEOPT) sprng.c -I$(SRCDIR)


#---------------------------------------------------------------------------
# Time the generator
#---------------------------------------------------------------------------
timesprng :
	(cd ..; $(MAKE) timesprng_exec TIMESPRNG_LIB=sprng)


#---------------------------------------------------------------------------
# Check portability of generator
#---------------------------------------------------------------------------
checksprng :
	(cd ..; $(MAKE) checksprng_exec CHECKSPRNG_LIB=sprng)


#---------------------------------------------------------------------------
.F.f : 
	@if [ -f $*.i ] ; then \
	rm $*.i ;\
	fi
	$(CPP) $*.F
	@if [ -f $*.i ] ; then \
	mv $*.i  $*.f ;\
	fi

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------
clean :
	rm -f *.o *.i

realclean :
	rm -f *.o *.f *~ *.i core a.out

.SUFFIXES : 

.SUFFIXES : .f .F

=== debian/changelog ===
sprng (2.0a-17) unstable; urgency=medium

  * debian/rules: Updated				(Closes: #1124903)

  * debian/control: Updated Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 07 Jan 2026 07:46:30 -0600

sprng (2.0a-16) unstable; urgency=medium

  * debian/patches/accumulated_patches: Ensure gmp is included via '<gmp.h'
  to pick system one. Thanks to Étienne Mollier. 	(Closes: #1079526)

  * debian/control: Updated Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 26 Aug 2024 06:25:18 -0500

sprng (2.0a-15) unstable; urgency=medium

  * debian/patches/accumulated_patches: Remove accidentally hard-wired gcc-14
  							(Closes: #1077743)

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 01 Aug 2024 06:29:47 -0500

sprng (2.0a-14) unstable; urgency=medium

  * Added includes to satisfy gcc-14			(Closes: 1075536)

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 27 Jul 2024 08:17:09 -0500
 

sprng (2.0a-13) unstable; urgency=medium

  * Repairing broken unusable (binary) non-coordindated previous upload
  * Removing several wrongly committed build artifacts

  * debian/control: Updated Standards-Version: current version
  * debian/compat: Increased to 10

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 28 Aug 2020 21:50:44 -0500

sprng (2.0a-12.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gcc-10
    Closes: #957837

 -- Andreas Tille <tille@debian.org>  Thu, 13 Aug 2020 12:41:22 +0200

sprng (2.0a-12) unstable; urgency=medium

  * debian/*: Update a few files while moving package to salsa.debian.org

  * debian/rules: Allow cross tools use by invoking build via dh_auto_build
  (with thanks to Helmut Grohne) 			(Closes: #904142)

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 21 Jul 2018 07:53:05 -0500

sprng (2.0a-11) unstable; urgency=medium

  * Makefile: Minor pedantic issue addressed		(Closes: #865692)

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 21 Jul 2017 06:30:15 -0500

sprng (2.0a-10) unstable; urgency=medium

  * SRC/insertmenu: Remove a bashism (with thanks to Reiner Herrmann, and
  this time do it directly rather than rely on patch system)
  							(Closes: #818762)
  * debian/control: Remove quilt from Build-Depends

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 23 Mar 2016 18:09:50 -0500

sprng (2.0a-9) unstable; urgency=low

  * debian/control: Switch libsprng2 to Section: libs

  * SRC/insertmenu: Remove a bashism (with thanks to Reiner Herrmann)
  							(Closes: #818762)

  * debian/rules: Use dh_prep instead of dh_clean -p
  * debian/rules: Add build-arch, build-indep targets
  * debian/control: Add quilt to Build-Depends
  * debian/control: Updated Standards-Version: to 3.9.6
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 20 Mar 2016 10:15:39 -0500

sprng (2.0a-8) unstable; urgency=low

  * debian/rules, SRC/make.GENERIC: Applied patch kindly supplied by
    Konstantinos Margaritis to address a build regression on armhf systems
  							(Closes: #627254)
  
  * debian/control: Removed article from beginning of Description: 
  								[lintian]
  
 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 18 May 2011 19:10:54 -0500

sprng (2.0a-7) unstable; urgency=low

  * SRC/pmlcg/longlong.h: Applied patch kindly supplied by Aurelien Jarno
    to address builds on mips/mipsel with recent gcc versions (>= 4.4)
							(Closes: #623015)  
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 16 Apr 2011 12:25:34 -0500

sprng (2.0a-6) unstable; urgency=low

  * debian/control: Updated Build-Depends: to libgmp-dev
  * debian/control: Updated Standards-Version: to 3.9.1

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 06 Mar 2011 10:13:54 -0600

sprng (2.0a-5) unstable; urgency=low

  * debian/control: Changed Section: of libsprng2-doc to 'doc' to satisfy
    a Lintian warning and a wishlist bug report		(Closes: #515925)

  * debian/control: Updated Standards-Version: to 3.8.0

  * debian/copyright: Updated to newer format

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 18 Feb 2009 20:22:14 -0600

sprng (2.0a-4) unstable; urgency=low

  * debian/control: Changed use ${binary:Version} and ${source:Version} to 
    allow for binNMUs. Thanks to Lior Kaplan for the patch   (Closes: #437501)
  * debian/control: Set Depends: of -doc toe (>= ${source:Version}) [lintian]
    
  * debian/control: Upgraded Standards-Version: to 3.7.2
  * debian/compat: Created, set version to 5
  * debian/control: Upgraded Build-Depends to debhelper (>= 5.0.0)
  * debian/rules: Changed 'make realclean' invocation [lintian]
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 12 Aug 2007 18:10:28 -0500

sprng (2.0a-3) unstable; urgency=low

  * SRC/sprng/Makefile: Add $(GMPLIB) to libsprng build (Closes: #318050)
  * SRC/{make.GENERIC: Add ${GMPDEF} to CFLAGS and FFLAGS
  * debian/control: Added libgmp3-dev to Depends for libsprng2-dev 
  							(Closes: #318051)
  * debian/control: Increase Standards-Version: to 3.6.2.1

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 17 Jul 2005 10:58:54 -0500

sprng (2.0a-2) unstable; urgency=low

  * SRC/pmlcg/longlong.h: more patching for multi-line string literals

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 15 Jul 2004 13:27:14 -0500

sprng (2.0a-1) unstable; urgency=low

  * Initial Debian packaging

 -- Dirk Eddelbuettel <edd@debian.org>  Mon,  5 Jul 2004 21:26:37 -0500

=== debian/control ===
Source: sprng
Section: math
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 4.7.3
Build-Depends: debhelper (>= 10), libgmp-dev
Vcs-Browser: https://salsa.debian.org/edd/sprng
Vcs-Git: https://salsa.debian.org/edd/sprng.git
Homepage: http://www.sprng.org/

Package: libsprng2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SPRNG Scalable Parallel RNG library -- library package
 The SPRNG (Scalable Parallel Random Number Generator) library provides
 several RNGs that are suitable for use in parallel computing.
 .
 URL: http://sprng.cs.fsu.edu
 .
 This package provides the shared libraries needed to execute programs
 built with SPRNG.

Package: libsprng2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libsprng2 (= ${binary:Version}), libgmp-dev
Suggests: libsprng2-doc
Description: SPRNG Scalable Parallel RNG library -- development package
 The SPRNG (Scalable Parallel Random Number Generator) library provides
 several RNGs that are suitable for use in parallel computing.
 .
 URL: http://sprng.cs.fsu.edu
 .
 This package contains the header files, static libraries and symbolic 
 links that are need to compile programs using the SPRNG library.

Package: libsprng2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: SPRNG Scalable Parallel RNG library -- documentation package
 The SPRNG (Scalable Parallel Random Number Generator) library provides
 several RNGs that are suitable for use in parallel computing.
 .
 URL: http://sprng.cs.fsu.edu
 .
 This package contains files from the docs, examples and tests
 directories included in the source distribution.

=== debian/rules ===
#!/usr/bin/make -f
#                                                       -*- makefile -*-
# debian/rules file for the Debian/GNU Linux sprng package
# Copyright (C) 2004 - 2026 by Dirk Eddelbuettel <edd@debian.org>

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

source  := $(shell head -1 debian/changelog | awk '{print $$1}')
sonum   := 2
libpack := lib$(source)$(sonum)
devpack := $(libpack)-dev
#binpack := $(source)-bin
#docpack := $(source)-doc-pdf
debtmp	:= $(CURDIR)/debian/$(libpack)
debdoc	:= $(CURDIR)/debian/$(docpack)
arch 	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

arch            := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)
ifeq ($(arch),armhf)
export compilerflags = -O2 -D_REENTRANT -Wa,-mimplicit-it=thumb
else
export compilerflags = -O2 -D_REENTRANT
endif

export DEB_CXXFLAGS_MAINT_APPEND = ${compilerflags}

#export DH_VERBOSE=1
#export DH_COMPAT=3

upstream: get-orig-source
get-orig-source: 
        #lynx ftp://sources.redhat.com/pub/gsl
	lynx http://sprng.cs.fsu.edu/

build-arch: build
build-indep: build

build: build-stamp
build-stamp:
	dh_testdir

        # Add here commands to compile the package.
        #$(MAKE)
        ##  NB 'make src' makes just the library
        #$(MAKE) src
        ## dh_auto_build uses cross tools as needed
	dh_auto_build -- src

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	[ ! -f Makefile ] || $(MAKE) realclean

        # An executable forgotten in the upstream sources
	rm -rvf EXAMPLES/sprngD SRC/check_gen_simple SRC/check_gen_ptr

	dh_clean

install:
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs usr/lib usr/include/sprng 

        # Add here commands to install the package into debian/tmp.
        #$(MAKE) prefix=`pwd`/debian/tmp/usr install
        ##   NB 'make install' doesn't work as it doesn't honour $PREFIX
	make -n install 
        ##       so do it all by hand
	cp -vax lib/libsprng.so.2.0  $(debtmp)/usr/lib/
	(cd $(debtmp)/usr/lib && \
		ln -s libsprng.so.$(sonum).0 libsprng.so.$(sonum) && \
		ln -s libsprng.so.$(sonum).0 libsprng.so )
	cp -vax lib/libsprng.a $(debtmp)/usr/lib
	cp -vax include/* $(debtmp)/usr/include/sprng

        #dh_install
        # use older dh_movefiles instead	
	dh_movefiles --sourcedir=debian/$(libpack)
        # silence lintian
	rmdir -v debian/$(libpack)/usr/include/sprng
	rmdir -v debian/$(libpack)/usr/include

# Build architecture-independent files here.
binary-indep: #build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i	DOCS/ TESTS/ EXAMPLES/
#	dh_installexamples -i   
#	dh_installmenu -i
#	dh_installdebconf -i
#	dh_installlogrotate -i
#	dh_installemacsen -i
#	dh_installcatalogs -i
#	dh_installpam -i
#	dh_installmime -i
#	dh_installinit -i
#	dh_installcron -i
#	dh_installinfo -i
#	dh_undocumented -i
	dh_installman -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
#	dh_perl -i
#	dh_python -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a	
	dh_installexamples -a	
	dh_installmenu -a
#	dh_installdebconf -a
#	dh_installlogrotate -a
#	dh_installemacsen -a
#	dh_installcatalogs -a
#	dh_installpam -a
#	dh_installmime -a
#	dh_installinit -a
#	dh_installcron -a
#	dh_installinfo -a
#	dh_undocumented -a
	dh_installman -a
	dh_strip -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
#	dh_perl -a
#	dh_python -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

#binary: binary-indep binary-arch
binary: binary-arch binary-indep 
.PHONY: build clean binary-indep binary-arch binary install
